]> gitweb.factorcode.org Git - factor.git/blob - build.sh
build.sh: Add OS detection for Haiku.
[factor.git] / build.sh
1 #!/usr/bin/env bash
2
3 # Programs returning != 0 will not cause script to exit
4 set +e
5
6 # Case insensitive string comparison
7 shopt -s nocaseglob
8 #shopt -s nocasematch
9
10 ECHO=echo
11 OS=
12 ARCH=
13 WORD=
14 GIT_PROTOCOL=${GIT_PROTOCOL:="git"}
15 GIT_URL=${GIT_URL:=$GIT_PROTOCOL"://github.com/factor/factor.git"}
16 SCRIPT_ARGS="$*"
17
18 REQUIRE_CLANG_VERSION=3.1
19
20 # return 1 on found
21 test_program_installed() {
22     if ! [[ -n $(type -p $1) ]] ; then
23         return 0;
24     fi
25     return 1;
26 }
27
28 # return 1 on found
29 test_programs_installed() {
30     local installed=0;
31     $ECHO -n "Checking for all($*)..."
32     for i in "$@" ;
33     do
34         test_program_installed $i
35         if [[ $? -eq 1 ]]; then
36             installed=$(( $installed + 1 ))
37         fi
38     done
39     if [[ $installed -eq $# ]] ; then
40         $ECHO "found!"
41         return 1
42     else
43         $ECHO "all not found."
44         return 0
45     fi
46 }
47
48 exit_script() {
49     if [[ $FIND_MAKE_TARGET = true ]] ; then
50         # Must be echo not $ECHO
51         echo $MAKE_TARGET;
52     fi
53     exit $1
54 }
55
56 ensure_program_installed() {
57     local installed=0;
58     $ECHO -n "Checking for any($*)..."
59     for i in "$@" ;
60     do
61         test_program_installed $i
62         if [[ $? -eq 1 ]]; then
63             $ECHO "found $i!"
64             installed=$(( $installed + 1 ))
65             return
66         fi
67     done
68     $ECHO "none found."
69     $ECHO -n "Install "
70     if [[ $# -eq 1 ]] ; then
71         $ECHO -n $1
72     else
73         $ECHO -n "any of [ $* ]"
74     fi
75     $ECHO " and try again."
76     if [[ $OS == macosx ]] ; then
77         $ECHO "If you have Xcode 4.3 or higher installed, you must install the"
78         $ECHO "Command Line Tools from Xcode Preferences > Downloads in order"
79         $ECHO "to build Factor."
80     fi
81     exit_script 1;
82 }
83
84 check_ret() {
85     RET=$?
86     if [[ $RET -ne 0 ]] ; then
87        $ECHO $1 failed
88        exit_script 2
89     fi
90 }
91
92 set_downloader() {
93     test_program_installed wget
94     if [[ $? -ne 0 ]] ; then
95         DOWNLOADER="wget -nd"
96         DOWNLOADER_NAME=wget
97         return
98     fi
99     test_program_installed curl
100     if [[ $? -ne 0 ]] ; then
101         DOWNLOADER="curl -L -f -O"
102         DOWNLOADER_NAME=curl
103         return
104     fi
105     $ECHO "error: wget or curl required"
106     exit_script 11
107 }
108
109 set_md5sum() {
110     test_program_installed md5sum
111     if [[ $? -ne 0 ]] ; then
112         MD5SUM=md5sum
113     else
114         MD5SUM="md5 -r"
115     fi
116 }
117
118 semver_into() {
119     RE_SEMVER="^([0-9]*)\.([0-9]*)\.([0-9]*)-?(.*)?$" # 3.3.3-5
120     CLANG_RE_OLD="^([0-9]*)\.([0-9]*)-?(.*)?$" # 3.3-5
121     if [[ $1 =~ $RE_SEMVER ]] ; then
122         export "$2=${BASH_REMATCH[1]}"
123         export "$3=${BASH_REMATCH[2]}"
124         export "$4=${BASH_REMATCH[3]}"
125         export "$5=${BASH_REMATCH[4]}"
126     elif [[ $1 =~ $CLANG_RE_OLD ]] ; then
127         export "$2=${BASH_REMATCH[1]}"
128         export "$3=${BASH_REMATCH[2]}"
129         export "$4=0"
130         export "$5=${BASH_REMATCH[3]}"
131     else
132         echo "unsupported version number, please report a bug: $1"
133         exit 123
134     fi
135 }
136
137 clang_version_ok() {
138     CLANG_VERSION=$(clang --version | head -n1)
139     CLANG_VERSION_RE='^[a-zA-Z0-9 ]* version (.*)$' # 3.3-5
140     if [[ $CLANG_VERSION =~ $CLANG_VERSION_RE ]] ; then
141         export "CLANG_VERSION=${BASH_REMATCH[1]}"
142         local CLANG_MAJOR CLANG_MINOR CLANG_PATCH CLANG_SPECIAL
143         semver_into "$CLANG_VERSION" CLANG_MAJOR CLANG_MINOR CLANG_PATCH CLANG_SPECIAL
144         if [[ $CLANG_MAJOR -lt 3
145             || ( $CLANG_MAJOR -eq 3 && $CLANG_MINOR -le 1 )
146             ]] ; then
147             echo "clang version required >= $REQUIRE_CLANG_VERSION, got $CLANG_VERSION"
148             return 1
149         fi
150     else
151         return 1
152     fi
153     return 0
154 }
155
156 set_cc() {
157     # on Cygwin we MUST use the MinGW "cross-compiler", therefore check these first
158     # furthermore, we prefer 64 bit over 32 bit versions if both are available
159
160     # we need this condition so we don't find a mingw32 compiler on linux
161     if [[ $OS == windows ]] ; then
162         test_programs_installed x86_64-w64-mingw32-gcc x86_64-w64-mingw32-g++
163         if [[ $? -ne 0 ]] ; then
164             [ -z "$CC" ] && CC=x86_64-w64-mingw32-gcc
165             [ -z "$CXX" ] && CXX=x86_64-w64-mingw32-g++
166             return
167         fi
168
169         test_programs_installed i686-w64-mingw32-gcc i686-w64-mingw32-g++
170         if [[ $? -ne 0 ]] ; then
171             [ -z "$CC" ] && CC=i686-w64-mingw32-gcc
172             [ -z "$CXX" ] && CXX=i686-w64-mingw32-g++
173             return
174         fi
175     fi
176
177     test_programs_installed clang clang++
178     if [[ $? -ne 0 ]] && clang_version_ok ; then
179         [ -z "$CC" ] && CC=clang
180         [ -z "$CXX" ] && CXX=clang++
181         return
182     fi
183
184     # gcc and g++ will fail to correctly build Factor on Cygwin
185     test_programs_installed gcc g++
186     if [[ $? -ne 0 ]] ; then
187         [ -z "$CC" ] && CC=gcc
188         [ -z "$CXX" ] && CXX=g++
189         return
190     fi
191
192     $ECHO "error: high enough version of either (clang/clang++) or (gcc/g++) required!"
193     exit_script 10
194 }
195
196 set_make() {
197     case $OS in
198         freebsd) MAKE=gmake ;;
199         *) MAKE=make ;;
200     esac
201     if [[ $MAKE = 'gmake' ]] ; then
202         ensure_program_installed gmake
203     fi
204 }
205
206 check_installed_programs() {
207     ensure_program_installed chmod
208     ensure_program_installed uname
209     ensure_program_installed git
210     ensure_program_installed wget curl
211     ensure_program_installed clang x86_64-w64-mingw32-gcc i686-w64-mingw32-gcc gcc
212     ensure_program_installed clang++ x86_64-w64-mingw32-g++ i686-w64-mingw32-g++ g++ cl
213     ensure_program_installed make gmake
214     ensure_program_installed md5sum md5
215     ensure_program_installed cut
216 }
217
218 check_library_exists() {
219     GCC_TEST=factor-library-test.c
220     GCC_OUT=factor-library-test.out
221     $ECHO -n "Checking for library $1..."
222     $ECHO "int main(){return 0;}" > $GCC_TEST
223     $CC $GCC_TEST -o $GCC_OUT -l $1 2>&-
224     if [[ $? -ne 0 ]] ; then
225         $ECHO "not found."
226     else
227         $ECHO "found."
228     fi
229     $DELETE -f $GCC_TEST
230     check_ret $DELETE
231     $DELETE -f $GCC_OUT
232     check_ret $DELETE
233 }
234
235 check_X11_libraries() {
236     check_library_exists GL
237     check_library_exists X11
238     check_library_exists pango-1.0
239 }
240
241 check_gtk_libraries() {
242     check_library_exists gobject-2.0
243     check_library_exists gtk-x11-2.0
244     check_library_exists gdk-x11-2.0
245     check_library_exists gdk_pixbuf-2.0
246     check_library_exists gtkglext-x11-1.0
247     check_library_exists atk-1.0
248     check_library_exists gio-2.0
249     check_library_exists gdkglext-x11-1.0
250     check_library_exists pango-1.0
251 }
252
253
254 check_libraries() {
255     case $OS in
256             linux) check_X11_libraries
257                    check_gtk_libraries;;
258             unix) check_gtk_libraries;;
259     esac
260 }
261
262 check_factor_exists() {
263     if [[ -d "factor" ]] ; then
264         $ECHO "A directory called 'factor' already exists."
265         $ECHO "Rename or delete it and try again."
266         exit_script 4
267     fi
268 }
269
270 find_os() {
271     if [[ -n $OS ]] ; then return; fi
272     $ECHO "Finding OS..."
273     local uname_s=$(uname -s)
274     check_ret uname
275     case $uname_s in
276         CYGWIN_NT-5.2-WOW64) OS=windows;;
277         *CYGWIN_NT*) OS=windows;;
278         *CYGWIN*) OS=windows;;
279         MINGW32*) OS=windows;;
280         MINGW64*) OS=windows;;
281         MSYS_NT*) OS=windows;;
282         *darwin*) OS=macosx;;
283         *Darwin*) OS=macosx;;
284         *linux*) OS=linux;;
285         *Linux*) OS=linux;;
286         FreeBSD) OS=freebsd;;
287         Haiku) OS=haiku;;
288     esac
289 }
290
291 find_architecture() {
292     if [[ -n $ARCH ]] ; then return; fi
293     $ECHO "Finding ARCH..."
294     uname_m=$(uname -m)
295     check_ret uname
296     case $uname_m in
297        i386) ARCH=x86;;
298        i686) ARCH=x86;;
299        i86pc) ARCH=x86;;
300        amd64) ARCH=x86;;
301        ppc64) ARCH=ppc;;
302        *86) ARCH=x86;;
303        *86_64) ARCH=x86;;
304        iPhone5*[3-9]) ARCH=arm64;;
305        iPhone[6-9]*) ARCH=arm64;;
306        iPhone[1-9][0-9]*) ARCH=arm64;;
307        "Power Macintosh") ARCH=ppc;;
308     esac
309 }
310
311 find_num_cores() {
312     $ECHO "Finding num cores..."
313     NUM_CORES=1
314     uname_s=$(uname -s)
315     check_ret uname
316     case $uname_s in
317         CYGWIN_NT-5.2-WOW64 | *CYGWIN_NT* | *CYGWIN* | MINGW32*) NUM_CORES=$NUMBER_OF_PROCESSORS;;
318         *linux* | *Linux*) NUM_CORES=$(getconf _NPROCESSORS_ONLN || nproc);;
319         *darwin* | *Darwin* | freebsd) NUM_CORES=$(sysctl -n hw.ncpu);;
320     esac
321 }
322
323 echo_test_program() {
324     #! Must be 'echo'
325     echo -e "int main(){ return (long)(8*sizeof(void*)); }"
326 }
327
328 c_find_word_size() {
329     $ECHO "Finding WORD..."
330     C_WORD="factor-word-size"
331     echo_test_program | $CC -o $C_WORD -xc -
332     check_ret $CC
333     ./$C_WORD
334     WORD_OUT=$?
335     case $WORD in
336         32) ;;
337         64) ;;
338         *)
339             echo "Word size should be 32/64, got $WORD"
340             exit_script 15;;
341     esac
342     $DELETE -f $C_WORD
343     echo "$WORD_OUT"
344 }
345
346 intel_macosx_word_size() {
347     ensure_program_installed sysctl
348     $ECHO -n "Testing if your Intel Mac supports 64bit binaries..."
349     sysctl machdep.cpu.extfeatures | grep EM64T >/dev/null
350     if [[ $? -eq 0 ]] ; then
351         WORD=64
352         $ECHO "yes!"
353     else
354         WORD=32
355         $ECHO "no."
356     fi
357 }
358
359 find_word_size() {
360     if [[ -n $WORD ]] ; then return; fi
361     if [[ $OS == macosx && $ARCH == x86 ]] ; then
362         intel_macosx_word_size
363     else
364         WORD=$(find_word_size_cpp || c_find_word_size)
365     fi
366 }
367
368 find_word_size_cpp() {
369     SIXTY_FOUR='defined(__aarch64__) || defined(__x86_64__) || defined(_M_AMD64) || defined(__PPC64__) || defined(__64BIT__)'
370     THIRTY_TWO='defined(i386) || defined(__i386) || defined(__i386__) || defined(_MIX86)'
371     cc -E -xc <(echo -e "#if ${SIXTY_FOUR}\n64\n#elif ${THIRTY_TWO}\n32\n#endif") | tail -1
372 }
373
374 set_factor_binary() {
375     case $OS in
376         windows) FACTOR_BINARY=factor.com;;
377         *) FACTOR_BINARY=factor;;
378     esac
379 }
380
381 set_factor_library() {
382     case $OS in
383         windows) FACTOR_LIBRARY=factor.dll;;
384         macosx) FACTOR_LIBRARY=libfactor.dylib;;
385         *) FACTOR_LIBRARY=libfactor.a;;
386     esac
387 }
388
389 set_factor_image() {
390     FACTOR_IMAGE=factor.image
391     FACTOR_IMAGE_FRESH=factor.image.fresh
392 }
393
394 echo_build_info() {
395     $ECHO OS=$OS
396     $ECHO ARCH=$ARCH
397     $ECHO NUM_CORES=$NUM_CORES
398     $ECHO WORD=$WORD
399     $ECHO DEBUG=$DEBUG
400     $ECHO REPRODUCIBLE=$REPRODUCIBLE
401     $ECHO CURRENT_BRANCH=$CURRENT_BRANCH
402     $ECHO FACTOR_BINARY=$FACTOR_BINARY
403     $ECHO FACTOR_LIBRARY=$FACTOR_LIBRARY
404     $ECHO FACTOR_IMAGE=$FACTOR_IMAGE
405     $ECHO MAKE_TARGET=$MAKE_TARGET
406     $ECHO BOOT_IMAGE=$BOOT_IMAGE
407     $ECHO MAKE_IMAGE_TARGET=$MAKE_IMAGE_TARGET
408     $ECHO GIT_PROTOCOL=$GIT_PROTOCOL
409     $ECHO GIT_URL=$GIT_URL
410     $ECHO DOWNLOADER=$DOWNLOADER
411     $ECHO CC=$CC
412     $ECHO CXX=$CXX
413     $ECHO MAKE=$MAKE
414     $ECHO COPY=$COPY
415     $ECHO DELETE=$DELETE
416 }
417
418 check_os_arch_word() {
419     if ! [[ -n $OS && -n $ARCH && -n $WORD ]] ; then
420         $ECHO "OS: $OS"
421         $ECHO "ARCH: $ARCH"
422         $ECHO "WORD: $WORD"
423         $ECHO "OS, ARCH, or WORD is empty.  Please report this."
424
425         $ECHO $MAKE_TARGET
426         exit_script 5
427     fi
428 }
429
430 set_build_info() {
431     check_os_arch_word
432     if [[ $OS == linux && $ARCH == ppc ]] ; then
433         MAKE_IMAGE_TARGET=linux-ppc.32
434         MAKE_TARGET=linux-ppc-32
435     elif [[ $OS == windows && $ARCH == x86 && $WORD == 64 ]] ; then
436         MAKE_IMAGE_TARGET=windows-x86.64
437         MAKE_TARGET=windows-x86-64
438     elif [[ $OS == windows && $ARCH == x86 && $WORD == 32 ]] ; then
439         MAKE_IMAGE_TARGET=windows-x86.32
440         MAKE_TARGET=windows-x86-32
441     elif [[ $ARCH == x86 && $WORD == 64 ]] ; then
442         MAKE_IMAGE_TARGET=unix-x86.64
443         MAKE_TARGET=$OS-x86-64
444     elif [[ $ARCH == x86 && $WORD == 32 ]] ; then
445         MAKE_IMAGE_TARGET=unix-x86.32
446         MAKE_TARGET=$OS-x86-32
447     else
448         MAKE_IMAGE_TARGET=$ARCH.$WORD
449         MAKE_TARGET=$OS-$ARCH-$WORD
450     fi
451     BOOT_IMAGE=boot.$MAKE_IMAGE_TARGET.image
452 }
453
454 parse_build_info() {
455     ensure_program_installed cut
456     $ECHO "Parsing make target from command line: $1"
457     OS=$(echo $1 | cut -d '-' -f 1)
458     ARCH=$(echo $1 | cut -d '-' -f 2)
459     WORD=$(echo $1 | cut -d '-' -f 3)
460
461     if [[ $OS == linux && $ARCH == ppc ]] ; then WORD=32; fi
462     if [[ $OS == linux && $ARCH == arm ]] ; then WORD=32; fi
463     if [[ $OS == macosx && $ARCH == ppc ]] ; then WORD=32; fi
464
465     $ECHO "OS=$OS"
466     $ECHO "ARCH=$ARCH"
467     $ECHO "WORD=$WORD"
468 }
469
470 find_build_info() {
471     find_os
472     find_architecture
473     find_num_cores
474     set_cc
475     find_word_size
476     set_current_branch
477     set_factor_binary
478     set_factor_library
479     set_factor_image
480     set_build_info
481     set_downloader
482     set_make
483     echo_build_info
484 }
485
486 invoke_git() {
487     git "$@"
488     check_ret git
489 }
490
491 git_clone() {
492     $ECHO "Downloading the git repository from github.com..."
493     invoke_git clone $GIT_URL
494 }
495
496 update_script_name() {
497     $ECHO "$(dirname $0)/_update.sh"
498 }
499
500 update_script() {
501     local -r update_script=$(update_script_name)
502     local -r bash_path=$(which bash)
503     $ECHO "updating from ${CURRENT_BRANCH}"
504     $ECHO "#!$bash_path" >"$update_script"
505     $ECHO "git pull \"$GIT_URL\" ${CURRENT_BRANCH}" >>"$update_script"
506     $ECHO "if [[ \$? -eq 0 ]]; then exec \"$0\" $SCRIPT_ARGS; else echo \"git pull failed\"; exit 2; fi" \
507         >>"$update_script"
508     $ECHO "exit 0" >>"$update_script"
509
510     chmod 755 "$update_script"
511     exec "$update_script"
512 }
513
514 update_script_changed() {
515     invoke_git diff --stat "$(invoke_git merge-base HEAD FETCH_HEAD)" FETCH_HEAD | grep 'build\.sh' >/dev/null
516 }
517
518 git_fetch() {
519     $ECHO "Fetching the git repository from github.com..."
520     set_current_branch
521
522     rm -f "$(update_script_name)"
523     $ECHO git fetch "$GIT_URL" "${CURRENT_BRANCH}"
524     invoke_git fetch "$GIT_URL" "${CURRENT_BRANCH}"
525
526     if update_script_changed; then
527         $ECHO "Updating and restarting the build.sh script..."
528         update_script
529     else
530         $ECHO "Updating the working tree..."
531         invoke_git pull "$GIT_URL" "${CURRENT_BRANCH}"
532     fi
533 }
534
535 cd_factor() {
536     cd "factor"
537     check_ret cd
538 }
539
540 set_copy() {
541     case $OS in
542         windows) COPY=cp;;
543         *) COPY=cp;;
544     esac
545 }
546
547 set_delete() {
548     case $OS in
549         windows) DELETE=rm;;
550         *) DELETE=rm;;
551     esac
552 }
553
554 backup_factor() {
555     $ECHO "Backing up factor..."
556     $COPY $FACTOR_BINARY $FACTOR_BINARY.bak
557     $COPY $FACTOR_LIBRARY $FACTOR_LIBRARY.bak
558     $COPY $BOOT_IMAGE $BOOT_IMAGE.bak
559     $COPY $FACTOR_IMAGE $FACTOR_IMAGE.bak
560     $ECHO "Done with backup."
561 }
562
563 check_makefile_exists() {
564     if [[ ! -e "GNUmakefile" ]] ; then
565         $ECHO ""
566         $ECHO "***GNUmakefile not found***"
567         $ECHO "You are likely in the wrong directory."
568         $ECHO "Run this script from your factor directory:"
569         $ECHO "     ./build.sh"
570         exit_script 6
571     fi
572 }
573
574 invoke_make() {
575     check_makefile_exists
576     $MAKE $MAKE_OPTS "$@"
577     check_ret $MAKE
578 }
579
580 make_clean() {
581     invoke_make clean
582 }
583
584 make_factor() {
585     $ECHO "Building factor with $NUM_CORES cores"
586     invoke_make CC=$CC CXX=$CXX $MAKE_TARGET -j$NUM_CORES
587 }
588
589 make_clean_factor() {
590     make_clean
591     make_factor
592 }
593
594 current_git_branch() {
595     # git rev-parse --abbrev-ref HEAD # outputs HEAD for detached head
596     # outputs nothing for detached HEAD, which is fine for ``git fetch``
597     git describe --all --exact-match 2>/dev/null | sed 's=.*/=='
598 }
599
600 check_url() {
601     if [[ $DOWNLOADER_NAME == 'wget' ]]; then
602         if [[ $(wget -S --spider $1 2>&1 | grep 'HTTP/1.1 200 OK') ]]; then
603             return 0
604         else
605             return 1
606         fi
607     elif [[ $DOWNLOADER_NAME == 'curl' ]]; then
608         local code=$(curl -sL -w "%{http_code}\\n" "$1" -o /dev/null)
609         if [[ $code -eq 200 ]]; then return 0; else return 1; fi
610     else
611         $ECHO "error: wget or curl required in check_url"
612         exit_script 12
613     fi
614 }
615
616 # If we are on a branch, first try to get a boot image for that branch.
617 # Otherwise, just use `master`
618 set_boot_image_vars() {
619     set_current_branch
620     local url="http://downloads.factorcode.org/images/${CURRENT_BRANCH}/checksums.txt"
621     check_url $url
622     if [[ $? -eq 0 ]]; then
623         CHECKSUM_URL="$url"
624         BOOT_IMAGE_URL="http://downloads.factorcode.org/images/${CURRENT_BRANCH}/${BOOT_IMAGE}"
625     else
626         CHECKSUM_URL="http://downloads.factorcode.org/images/master/checksums.txt"
627         BOOT_IMAGE_URL="http://downloads.factorcode.org/images/master/${BOOT_IMAGE}"
628     fi
629 }
630
631 set_current_branch() {
632     if [ -n "${CI_BRANCH}" ]; then
633         CURRENT_BRANCH="${CI_BRANCH}"
634     else
635         CURRENT_BRANCH=$(current_git_branch)
636     fi
637 }
638
639 update_boot_image() {
640     set_boot_image_vars
641     $ECHO "Deleting old images..."
642     $DELETE checksums.txt* > /dev/null 2>&1
643     # delete boot images with one or two characters after the dot
644     $DELETE $BOOT_IMAGE.{?,??} > /dev/null 2>&1
645     $DELETE temp/staging.*.image > /dev/null 2>&1
646     if [[ -f $BOOT_IMAGE ]] ; then
647         get_url $CHECKSUM_URL
648         local factorcode_md5=$(cat checksums.txt | grep $BOOT_IMAGE | cut -f2 -d' ')
649         set_md5sum
650         local disk_md5=$($MD5SUM $BOOT_IMAGE | cut -f1 -d' ')
651         $ECHO "Factorcode md5: $factorcode_md5";
652         $ECHO "Disk md5: $disk_md5";
653         if [[ "$factorcode_md5" == "$disk_md5" ]] ; then
654             $ECHO "Your disk boot image matches the one on downloads.factorcode.org."
655         else
656             $DELETE $BOOT_IMAGE > /dev/null 2>&1
657             get_boot_image
658         fi
659     else
660         get_boot_image
661     fi
662 }
663
664 get_boot_image() {
665     $ECHO "Downloading boot image $BOOT_IMAGE."
666     get_url "${BOOT_IMAGE_URL}"
667 }
668
669 get_url() {
670     if [[ -z $DOWNLOADER ]] ; then
671         set_downloader;
672     fi
673     $ECHO $DOWNLOADER $1 ;
674     $DOWNLOADER $1
675     check_ret $DOWNLOADER
676 }
677
678 get_config_info() {
679     find_build_info
680     check_installed_programs
681     check_libraries
682 }
683
684 copy_fresh_image() {
685     $ECHO "Copying $FACTOR_IMAGE to $FACTOR_IMAGE_FRESH..."
686     $COPY $FACTOR_IMAGE $FACTOR_IMAGE_FRESH
687 }
688
689 bootstrap() {
690     ./$FACTOR_BINARY -i=$BOOT_IMAGE
691     copy_fresh_image
692 }
693
694 install() {
695     check_factor_exists
696     get_config_info
697     git_clone
698     cd_factor
699     make_factor
700     set_boot_image_vars
701     get_boot_image
702     bootstrap
703 }
704
705 update() {
706     get_config_info
707     git_fetch
708     backup_factor
709     make_clean_factor
710 }
711
712 download_and_bootstrap() {
713     update_boot_image
714     bootstrap
715 }
716
717 net_bootstrap_no_pull() {
718     get_config_info
719     make_clean_factor
720     download_and_bootstrap
721 }
722
723 refresh_image() {
724     ./$FACTOR_BINARY -e="USING: vocabs.loader vocabs.refresh system memory ; refresh-all save 0 exit"
725     check_ret factor
726 }
727
728 make_boot_image() {
729     ./$FACTOR_BINARY -run="bootstrap.image" "$MAKE_IMAGE_TARGET"
730     check_ret factor
731 }
732
733 install_deps_apt() {
734     sudo apt install --yes libc6-dev libpango1.0-dev libx11-dev xorg-dev libgtk2.0-dev gtk2-engines-pixbuf libgtkglext1-dev wget git git-doc rlwrap clang make screen tmux libssl-dev
735     check_ret sudo
736 }
737
738 install_deps_pacman() {
739     sudo pacman --noconfirm -Syu gcc clang make rlwrap git wget pango glibc gtk2 gtk3 gtkglext gtk-engines gdk-pixbuf2 libx11 screen tmux
740     check_ret sudo
741 }
742
743 install_deps_dnf() {
744     sudo dnf --assumeyes install gcc gcc-c++ glibc-devel binutils libX11-devel pango-devel gtk3-devel gdk-pixbuf2-devel gtkglext-devel tmux rlwrap wget
745     check_ret sudo
746 }
747
748 install_deps_pkg() {
749     sudo pkg install --yes git gmake gcc rlwrap ripgrep curl gmake x11-toolkits/gtk30 x11-toolkits/gtkglext pango cairo vim
750 }
751
752
753 install_deps_macosx() {
754     test_program_installed git
755     if [[ $? -ne 1 ]] ; then
756         ensure_program_installed yes
757         $ECHO "git not found."
758         $ECHO "This script requires either git-core or port."
759         $ECHO "If it fails, install git-core or port and try again."
760         ensure_program_installed port
761         $ECHO "Installing git-core with port...this will take awhile."
762         yes | sudo port install git-core
763     fi
764 }
765
766 usage() {
767     $ECHO "usage: $0 command [optional-target]"
768     $ECHO "  install - git clone, compile, bootstrap"
769     $ECHO "  deps-apt - install required packages for Factor on Linux using apt"
770     $ECHO "  deps-pacman - install required packages for Factor on Linux using pacman"
771     $ECHO "  deps-dnf - install required packages for Factor on Linux using dnf"
772     $ECHO "  deps-pkg - install required packages for Factor on FreeBSD using pkg"
773     $ECHO "  deps-macosx - install git on MacOSX using port"
774     $ECHO "  self-update - git pull, recompile, make local boot image, bootstrap"
775     $ECHO "  quick-update - git pull, refresh-all, save"
776     $ECHO "  update|latest - git pull, recompile, download a boot image, bootstrap"
777     $ECHO "  compile - compile the binary"
778     $ECHO "  recompile - recompile the binary"
779     $ECHO "  bootstrap - bootstrap with existing boot image"
780     $ECHO "  net-bootstrap - recompile, download a boot image, bootstrap"
781     $ECHO "  make-target - find and print the os-arch-cpu string"
782     $ECHO "  report|info - print the build variables"
783     $ECHO "  update-boot-image - get the boot image for the current branch of for master"
784     $ECHO ""
785     $ECHO "If you are behind a firewall, invoke as:"
786     $ECHO "env GIT_PROTOCOL=http $0 <command>"
787     $ECHO ""
788     $ECHO "Example for overriding the default target:"
789     $ECHO "    $0 update macosx-x86-32"
790 }
791
792 MAKE_TARGET=unknown
793
794 # -n is nonzero length, -z is zero length
795 if [[ -n "$2" ]] ; then
796     parse_build_info $2
797 fi
798
799 if [ "$#" -gt 3 ]; then
800     usage
801     $ECHO "error: too many arguments"
802     exit 1
803 fi
804
805
806 set_copy
807 set_delete
808
809 case "$1" in
810     install) install ;;
811     deps-apt) install_deps_apt ;;
812     deps-pacman) install_deps_pacman ;;
813     deps-macosx) install_deps_macosx ;;
814     deps-dnf) install_deps_dnf ;;
815     deps-pkg) install_deps_pkg ;;
816     self-bootstrap) get_config_info; make_boot_image; bootstrap;;
817     self-update) update; make_boot_image; bootstrap;;
818     quick-update) update; refresh_image ;;
819     update|latest) update; download_and_bootstrap ;;
820     compile) find_build_info; make_factor ;;
821     recompile) find_build_info; make_clean; make_factor ;;
822     bootstrap) get_config_info; bootstrap ;;
823     net-bootstrap) net_bootstrap_no_pull ;;
824     make-target) FIND_MAKE_TARGET=true; ECHO=false; find_build_info; exit_script ;;
825     report|info) find_build_info ;;
826     full-report) find_build_info; check_installed_programs; check_libraries ;;
827     update-boot-image) find_build_info; check_installed_programs; update_boot_image;;
828     *) usage ;;
829 esac
830